/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2020  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region.dynamic;

import lombok.NonNull;

import java.io.File;
import java.time.LocalDate;
import java.util.Objects;
import java.util.Optional;
import java.util.Random;

public interface VariantSelector {

    Optional<File> selectVariant(int minX, int minZ);

    default VariantSelector or(VariantSelector other) {
        return (minX, minZ) -> selectVariant(minX, minZ).or(() -> other.selectVariant(minX, minZ));
    }

    static VariantSelector AtDate(int day, int month, File file) {
        return (minX, minZ) -> {
            LocalDate date = LocalDate.now();
            if (date.getDayOfMonth() == day && date.getMonthValue() == month) {
                return Optional.of(file);
            } else {
                return Optional.empty();
            }
        };
    }

    static VariantSelector File(@NonNull File file) {
        return (minX, minZ) -> Optional.of(file);
    }

    static VariantSelector StableVariants(@NonNull File directory) {
        File[] files = directory.listFiles();
        Random rand = new Random();
        return (minX, minZ) -> {
            rand.setSeed(Objects.hash(minX, minZ));
            return Optional.of(files[rand.nextInt(files.length)]);
        };
    }

    static VariantSelector RandomVariants(@NonNull File directory) {
        File[] files = directory.listFiles();
        Random rand = new Random();
        return (minX, minZ) -> {
            return Optional.of(files[rand.nextInt(files.length)]);
        };
    }
}
